#define std_io_ByteArrayInputTube_IMPORT
#define std_io_InputTube_IMPORT
#define std_lang_Object_IMPORT

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <std/io/impl/ByteArrayInputTube.h>

union BAIT {
    struct impl_InputTube *inputTube;
    struct impl_ByteArrayInputTube *byteArrayInputTube;
} __attribute__((__transparent_union__));

static ssize_t
BAIT_read(union BAIT this, void *data, size_t size)
{
    struct impl_ByteArrayInputTube *impl = this.byteArrayInputTube;

    if (impl->size == 0)
	return 0;
    if (size > impl->size)
	size = impl->size;
    memcpy(data, impl->data, size);
    impl->data += size;
    impl->size -= size;
    return size;
}

static int
BAIT_close(union BAIT this)
{
    struct impl_ByteArrayInputTube *impl = this.byteArrayInputTube;

    free(impl);
    return 0;
}

static const struct InputTube_Methods BAIT_METHODS = {
    .read = BAIT_read,
    .close = BAIT_close};

union ByteArrayInputTube
ByteArrayInputTube_create(const void *data, size_t size)
{
    struct impl_ByteArrayInputTube *impl;

    if ((impl = malloc(sizeof(*impl))) == NULL) {
	return (union ByteArrayInputTube)Object_NULL;
    }
    InputTube_initialize(&impl->super.inputTube, &BAIT_METHODS);
    impl->data = data;
    impl->size = size;
    return (union ByteArrayInputTube)impl;
}
